#include <iostream>
#include <stack>
using namespace std;
int mat[2000][2000];
/*
Input:
3 4
1 2 3 4
5 6 7 8
9 10 11 12
2
1 2
2 4
*/

bool isSafe(int n, int m, int i, int j, int blokI, int blokJ) {
    if (i >= 0 && j >= 0 && i < n && j < m  && (i != blokI || j != blokJ)) return true;
    return false;
}


int main() {
    int m, n, q;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mat[i][j];
        }
    }

    cin >> q;
    int blokI, blokJ;

    for (int k = 0; k < q; k++) {
        cin >> blokI >> blokJ;
        int zbirNavijaca = 0;
        int trenutnoI = 0, trenutnoJ = 0;
        blokI--;
        blokJ--;

        stack<pair<int, int>> stek;
        stek.push(pair<int, int>(0, 0));

        while (!stek.empty()) {

            pair<int, int> p = stek.top();
            stek.pop();

            int trenutnoI = p.first, trenutnoJ = p.second;
            int elementDesni = INT_MAX, elementDonji = INT_MAX;
            zbirNavijaca += mat[trenutnoI][trenutnoJ];
            if (trenutnoI == n - 1 && trenutnoJ == m - 1) break;

            if (isSafe(n, m, trenutnoI + 1, trenutnoJ, blokI, blokJ))
                elementDonji = mat[trenutnoI + 1][trenutnoJ];
            if (isSafe(n, m, trenutnoI, trenutnoJ + 1, blokI, blokJ))
                elementDesni = mat[trenutnoI][trenutnoJ+1];

            if (elementDonji > elementDesni) {
                if (elementDonji != INT_MAX) stek.push(pair<int, int>(trenutnoI + 1, trenutnoJ));
                if (elementDesni != INT_MAX) stek.push(pair<int, int>(trenutnoI, trenutnoJ + 1));
            }
            else {
                if (elementDesni != INT_MAX) stek.push(pair<int, int>(trenutnoI, trenutnoJ + 1));
                if (elementDonji != INT_MAX) stek.push(pair<int, int>(trenutnoI + 1, trenutnoJ));
            }
            if (elementDesni == INT_MAX && elementDonji == INT_MAX && !stek.empty())
                zbirNavijaca -= mat[trenutnoI][trenutnoJ];

        }

        cout << zbirNavijaca << "\n";

    }

    return 0;
}